package cn.qqck.kotlin.tools

import java.text.SimpleDateFormat
import java.util.Date

object Date {
    /**
     * 获取当前时间的某一天的零点对应的时间戳（毫秒）。
     *
     * 该方法默认返回当前时间对应的当日零点时间戳。如果需要推移日期，可以通过参数指定推移的天数。
     *
     * @param add 需要推移的天数，正数表示往后推移，负数表示往前推移，默认为 0（表示今天）。
     * @return 指定日期零点的时间戳，单位为毫秒。
     */
    fun day(add: Long = 0): Long {
        return (System.currentTimeMillis() + 28800000) / 86400000 * 86400000 - 28800000 + add * 86400000
    }
}

private val format_yMdHms = SimpleDateFormat("yyyy-MM-dd HH:mm:ss")
private val format_yMd = SimpleDateFormat("yyyy-MM-dd")
private val format_Hms = SimpleDateFormat("HH:mm:ss")
private val format_Hm = SimpleDateFormat("HH:mm")

fun Date.yMdHms(): String = format_yMdHms.format(this)
fun Date.yMd(): String = format_yMd.format(this)
fun Date.Hms(): String = format_Hms.format(this)
fun Date.Hm(): String = format_Hm.format(this)

fun Long.yMdHms(): String = Date(this).yMdHms()
fun Long.yMd(): String = Date(this).yMd()
fun Long.Hms(): String = Date(this).Hms()
fun Long.Hm(): String = Date(this).Hm()
